# coding: utf-8

"""
    Arduino IoT Cloud API

     Provides a set of endpoints to manage Arduino IoT Cloud **Devices**, **Things**, **Properties** and **Timeseries**. This API can be called just with any HTTP Client, or using one of these clients:  * [Javascript NPM package](https://www.npmjs.com/package/@arduino/arduino-iot-client)  * [Python PYPI Package](https://pypi.org/project/arduino-iot-client/)  * [Golang Module](https://github.com/arduino/iot-client-go)  # noqa: E501

    The version of the OpenAPI document: 2.0
    Generated by: https://openapi-generator.tech
"""

from datetime import date, datetime  # noqa: F401
import decimal  # noqa: F401
import functools  # noqa: F401
import io  # noqa: F401
import re  # noqa: F401
import typing  # noqa: F401
import typing_extensions  # noqa: F401
import uuid  # noqa: F401

import frozendict  # noqa: F401

from iot_api_client import schemas  # noqa: F401


class ArduinoLinkedvariable(
    schemas.DictSchema
):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.

    ArduinoLinkedvariable media type (default view)
    """


    class MetaOapg:
        required = {
            "thing_name",
            "thing_id",
            "name",
            "permission",
            "id",
            "variable_name",
            "type",
        }
        
        class properties:
            id = schemas.UUIDSchema
            name = schemas.StrSchema
            permission = schemas.StrSchema
            thing_id = schemas.UUIDSchema
            thing_name = schemas.StrSchema
            type = schemas.StrSchema
            variable_name = schemas.StrSchema
            last_value = schemas.AnyTypeSchema
            last_value_updated_at = schemas.DateTimeSchema
        
            @staticmethod
            def thing_timezone() -> typing.Type['ArduinoTimezone']:
                return ArduinoTimezone
            __annotations__ = {
                "id": id,
                "name": name,
                "permission": permission,
                "thing_id": thing_id,
                "thing_name": thing_name,
                "type": type,
                "variable_name": variable_name,
                "last_value": last_value,
                "last_value_updated_at": last_value_updated_at,
                "thing_timezone": thing_timezone,
            }
    
    thing_name: MetaOapg.properties.thing_name
    thing_id: MetaOapg.properties.thing_id
    name: MetaOapg.properties.name
    permission: MetaOapg.properties.permission
    id: MetaOapg.properties.id
    variable_name: MetaOapg.properties.variable_name
    type: MetaOapg.properties.type
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["id"]) -> MetaOapg.properties.id: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["name"]) -> MetaOapg.properties.name: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["permission"]) -> MetaOapg.properties.permission: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["thing_id"]) -> MetaOapg.properties.thing_id: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["thing_name"]) -> MetaOapg.properties.thing_name: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["type"]) -> MetaOapg.properties.type: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["variable_name"]) -> MetaOapg.properties.variable_name: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["last_value"]) -> MetaOapg.properties.last_value: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["last_value_updated_at"]) -> MetaOapg.properties.last_value_updated_at: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["thing_timezone"]) -> 'ArduinoTimezone': ...
    
    @typing.overload
    def __getitem__(self, name: str) -> schemas.UnsetAnyTypeSchema: ...
    
    def __getitem__(self, name: typing.Union[typing_extensions.Literal["id", "name", "permission", "thing_id", "thing_name", "type", "variable_name", "last_value", "last_value_updated_at", "thing_timezone", ], str]):
        # dict_instance[name] accessor
        return super().__getitem__(name)
    
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["id"]) -> MetaOapg.properties.id: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["name"]) -> MetaOapg.properties.name: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["permission"]) -> MetaOapg.properties.permission: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["thing_id"]) -> MetaOapg.properties.thing_id: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["thing_name"]) -> MetaOapg.properties.thing_name: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["type"]) -> MetaOapg.properties.type: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["variable_name"]) -> MetaOapg.properties.variable_name: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["last_value"]) -> typing.Union[MetaOapg.properties.last_value, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["last_value_updated_at"]) -> typing.Union[MetaOapg.properties.last_value_updated_at, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["thing_timezone"]) -> typing.Union['ArduinoTimezone', schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: str) -> typing.Union[schemas.UnsetAnyTypeSchema, schemas.Unset]: ...
    
    def get_item_oapg(self, name: typing.Union[typing_extensions.Literal["id", "name", "permission", "thing_id", "thing_name", "type", "variable_name", "last_value", "last_value_updated_at", "thing_timezone", ], str]):
        return super().get_item_oapg(name)
    

    def __new__(
        cls,
        *_args: typing.Union[dict, frozendict.frozendict, ],
        thing_name: typing.Union[MetaOapg.properties.thing_name, str, ],
        thing_id: typing.Union[MetaOapg.properties.thing_id, str, uuid.UUID, ],
        name: typing.Union[MetaOapg.properties.name, str, ],
        permission: typing.Union[MetaOapg.properties.permission, str, ],
        id: typing.Union[MetaOapg.properties.id, str, uuid.UUID, ],
        variable_name: typing.Union[MetaOapg.properties.variable_name, str, ],
        type: typing.Union[MetaOapg.properties.type, str, ],
        last_value: typing.Union[MetaOapg.properties.last_value, dict, frozendict.frozendict, str, date, datetime, uuid.UUID, int, float, decimal.Decimal, bool, None, list, tuple, bytes, io.FileIO, io.BufferedReader, schemas.Unset] = schemas.unset,
        last_value_updated_at: typing.Union[MetaOapg.properties.last_value_updated_at, str, datetime, schemas.Unset] = schemas.unset,
        thing_timezone: typing.Union['ArduinoTimezone', schemas.Unset] = schemas.unset,
        _configuration: typing.Optional[schemas.Configuration] = None,
        **kwargs: typing.Union[schemas.AnyTypeSchema, dict, frozendict.frozendict, str, date, datetime, uuid.UUID, int, float, decimal.Decimal, None, list, tuple, bytes],
    ) -> 'ArduinoLinkedvariable':
        return super().__new__(
            cls,
            *_args,
            thing_name=thing_name,
            thing_id=thing_id,
            name=name,
            permission=permission,
            id=id,
            variable_name=variable_name,
            type=type,
            last_value=last_value,
            last_value_updated_at=last_value_updated_at,
            thing_timezone=thing_timezone,
            _configuration=_configuration,
            **kwargs,
        )

from iot_api_client.model.arduino_timezone import ArduinoTimezone
